import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Solution to Light Up
 * 
 * @author vanb
 */
public class lightup_vanb
{
    /** Input. */
    private static Scanner sc;
    
    /** Output. */
    private static PrintStream ps;
    
    private void dump( char grid[][] )
    {
        for( char row[] : grid )
        {
            System.err.println( new String( row ) );
        }
    }
    
    /**
     * Do it!
     */
    private void doit()
    {
        int n = sc.nextInt();
        char grid[][] = new char[n][];
        for( int i=0; i<n; i++ )
        {
            grid[i] = sc.next().toCharArray();
        }
        
        // Is everything OK?
        boolean ok = true;
        
        // Go through every grid cell
        for( int i=0; i<n; i++ ) for( int j=0; j<n; j++ )
        {
            if( grid[i][j]=='?' )
            {
                // If it's a light bulb, shine it in all 4 directions until it hits the edge or a non-empty cell.
                // If it hits another bulb, that's bad. We'll use '#' to mark a lit cell. 
                // It's OK for an empty cell to be lit by more than one bulb.
                int d;
                for( d=i-1; d>=0 && (grid[d][j]=='.' || grid[d][j]=='#'); --d ) grid[d][j] = '#';
                if( d>=0 && grid[d][j]=='?' ) ok = false;
                for( d=i+1; d<n && (grid[d][j]=='.' || grid[d][j]=='#'); ++d ) grid[d][j] = '#';
                if( d<n && grid[d][j]=='?' ) ok = false;
                for( d=j-1; d>=0 && (grid[i][d]=='.' || grid[i][d]=='#'); --d ) grid[i][d] = '#';
                if( d>=0 && grid[i][d]=='?' ) ok = false;
                for( d=j+1; d<n && (grid[i][d]=='.' || grid[i][d]=='#'); ++d ) grid[i][d] = '#';
                if( d<n && grid[i][d]=='?' ) ok = false;
            }
            else if( Character.isDigit( grid[i][j] ) )
            {
                // If it's a number, look up, down, left, right, and make sure that the count of light bulbs matches the constraint.
                int constraint = grid[i][j] - '0';
                int count = 0;
                if( i-1>=0 && grid[i-1][j]=='?' ) ++count;
                if( i+1<n && grid[i+1][j]=='?' ) ++count;
                if( j-1>=0 && grid[i][j-1]=='?' ) ++count;
                if( j+1<n && grid[i][j+1]=='?' ) ++count;
                if( count!=constraint ) ok = false; 
            }
        }

        // Look to see if there are any unlit cells
        for( int i=0; i<n; i++ ) for( int j=0; j<n; j++ )
        {
            if( grid[i][j]=='.' ) ok = false;
        }

        ps.println( ok ? 1 : 0 );
    }
        
    /**
     * Main.
     * 
     * @param args unused
     * @throws Exception
     */
    public static void main( String[] args ) throws Exception
    {
        sc = new Scanner( System.in );
        ps = System.out;
        
        new lightup_vanb().doit();
    }

}
